    .386
    .model flat, stdcall  ; .

    option casemap :none  ; p MASM   
                          ;  pp.
                          ;    
                          ;windows.inc-.

    ;    inc-  .	
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\gdi32.inc
    include \masm32\include\windows.inc
    include \masm32\include\comdlg32.inc

    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\gdi32.lib
    includelib \masm32\lib\comdlg32.lib

    ;===============================
    ;   
    ;===============================
        szText MACRO Name, Text:VARARG
          LOCAL lbl
            jmp lbl
              Name db Text,0
            lbl:
          ENDM

        m2m MACRO M1, M2
          push M2
          pop  M1
        ENDM

        return MACRO arg
          mov eax, arg
          ret
        ENDM

    ;=========================================
    ;     
    ;=========================================
        WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY PROTO   :DWORD,:DWORD

    .data
      ;  
        szDisplayName db "  ",0	
      ;  
        CommandLine   dd ?
      ; 
        hWnd          dd ?
      ; 
        hInstance     dd ?
      ;  
        hMenu         dd ?
      ;     
        hMemBkDC       dd ?
      ;     
        hMemDC         dd ?
      ;       
        hPen          dd ?
        hLBrush	      dd ?
        hRBrush	      dd ?
        hLSPen        dd ?
        hRSPen        dd ?
      ;      
        RColor        dd 000000h  ;clBlack
        LColor        dd 000080h  ;clMaroon
      ;       
        cRect         RECT <?>			
      ;      
        sPosX         dd ?
        sPosY         dd ?
        cPosX         dd ?
        cPosY         dd ?
      ;  : 0-,1-,2-,3-.,4-,5-.
        sFF	      db ?
      ;  : 1-,2-,3-.,4-,5-.
        cFF           db 1
      ;  
        sPen          dd 3
      ;  
        XM            dd ?
        YM            dd ?
      ;     
        Menu103       dd 10301h
        Menu104       dd 10401h
        Menu105       dd 10500h
        Menu106       dd 10603h
      ;  
        RGBW          equ (80 or (80 shl 8)) or (255 shl 16)
      ;   
        Color         dd 000000h  ;clBlack
                      dd 000080h  ;clMaroon
        	      dd 008000h  ;clGreen
                      dd 008080h  ;clOlive
                      dd 800000h  ;clNavy
                      dd 800080h  ;clPurple
                      dd 808000h  ;clTeal
                      dd 808080h  ;clGray
                      dd 0C0C0C0h ;clSilver
                      dd 0000FFh  ;clRed
                      dd 00FF00h  ;clLime
                      dd 00FFFFh  ;clYellow
                      dd 0FF0000h ;clBlue
                      dd 0FF00FFh ;clFuchsia
                      dd 0FFFF00h ;clAqua
                      dd 0C0C0C0h ;clLtGray
                      dd 808080h  ;clDkGray
                      dd 0FFFFFFh ;clWhite
      ;  ChooseColor 
        cc            CHOOSECOLOR <?>
      ;   ChooseColor 
        CCCustColors  dd 000000h  ;clBlack
                      dd 000080h  ;clMaroon
        	      dd 008000h  ;clGreen
                      dd 008080h  ;clOlive
                      dd 800000h  ;clNavy
                      dd 800080h  ;clPurple
                      dd 808000h  ;clTeal
                      dd 808080h  ;clGray
                      dd 0C0C0C0h ;clSilver
                      dd 0000FFh  ;clRed
                      dd 00FF00h  ;clLime
                      dd 00FFFFh  ;clYellow
                      dd 0FF0000h ;clBlue
                      dd 0FF00FFh ;clFuchsia
                      dd 0FFFF00h ;clAqua
                      dd 0FFFFFFh ;clWhite
    .code

start:
    invoke GetModuleHandle, NULL	;  
    mov hInstance, eax
    invoke GetCommandLine		;   
    mov CommandLine, eax
    invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
    invoke ExitProcess,eax		;   ( ).

WinMain proc hInst     :DWORD,
             hPrevInst :DWORD,
             CmdLine   :DWORD,
             CmdShow   :DWORD

    ;===============================
    ;  "" 
    ;===============================
        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG
        LOCAL Wwd  :DWORD
        LOCAL Wht  :DWORD
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD

    szText szClassName,"Class32"	; 

    ;================================================
    ;  WNDCLASSEX   
    ;================================================
        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW + CS_VREDRAW + CS_SAVEBITS + CS_OWNDC
        mov wc.lpfnWndProc,    offset WndProc
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hInst

  ;   (NULL-   )
    mov wc.hbrBackground,  NULL	

    mov wc.lpszMenuName,   NULL
    mov wc.lpszClassName,  offset szClassName
  ;  
      invoke LoadIcon,7F00h,0
    mov wc.hIcon,          eax
  ;    1000   
    invoke LoadCursor,hInst,3e8h
    mov wc.hCursor,        eax
    mov wc.hIconSm,        0

    invoke RegisterClassEx, ADDR wc	;  "Class32"

  ;         
  ;      
    mov Wwd, 500
    mov Wht, 300
    invoke GetSystemMetrics,SM_CXSCREEN
    mov XM,eax
    invoke TopXY,Wwd,eax
    mov Wtx, eax
    invoke GetSystemMetrics,SM_CYSCREEN
    mov YM,eax
    invoke TopXY,Wht,eax
    mov Wty, eax

  ;   
    invoke CreateWindowEx,0,
                          ADDR szClassName,
                          ADDR szDisplayName,
                          WS_OVERLAPPED + WS_CAPTION + WS_SYSMENU + \
                          WS_MINIMIZEBOX + WS_MAXIMIZEBOX + WS_THICKFRAME,
                          Wtx,Wty,Wwd,Wht,
                          NULL,NULL,
                          hInst,NULL
    mov hWnd,eax

    invoke LoadMenu,hInst,2		;    2
    mov hMenu,eax
    invoke SetMenu,hWnd,eax		;    

  ;  
    invoke ShowWindow,hWnd,SW_SHOWNORMAL
  ;  
    invoke UpdateWindow,hWnd

    ;==========================
    ;   
    ;==========================
        StartLoop:
          invoke GetMessage,ADDR msg,NULL,0,0
          cmp eax, 0
          je ExitLoop
          invoke DispatchMessage,  ADDR msg
          jmp StartLoop
        ExitLoop:

    return msg.wParam
WinMain endp

;    
WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD

    ;===============================
    ;  "" 
    ;===============================
	LOCAL hDC  :DWORD
	LOCAL Ps   :PAINTSTRUCT

   .if uMsg == WM_MOUSEMOVE
      ;     ,
      ;   ,     
        .if sFF == 0
            return 0
        .endif
      ;    
      ;       
        mov ecx, 0h
        mov cx, WORD PTR [lParam]
        mov cPosX, ecx
        mov cx, WORD PTR [lParam+2h]
        mov cPosY, ecx

      ;    MemBkDC  MemDC
      ;      
        invoke BitBlt,hMemDC,0,0,XM,YM,hMemBkDC,0,0,SRCCOPY
        .if sFF == 1
            invoke MoveToEx,hMemDC,sPosX,sPosY,NULL
            invoke LineTo,hMemDC,cPosX,cPosY
        .elseif sFF == 2
            invoke Ellipse,hMemDC,cPosX,cPosY,sPosX,sPosY
        .elseif sFF == 4
            invoke Rectangle,hMemDC,cPosX,cPosY,sPosX,sPosY
        .elseif sFF == 3
            invoke Arc,hMemDC,cPosX,cPosY,sPosX,sPosY,0,0,0,0
        .elseif sFF == 5
            invoke MoveToEx,hMemDC,sPosX,sPosY,NULL
            invoke LineTo,hMemDC,cPosX,sPosY
            invoke LineTo,hMemDC,cPosX,cPosY
            invoke LineTo,hMemDC,sPosX,cPosY
            invoke LineTo,hMemDC,sPosX,sPosY
        .endif
      ;  
        invoke RedrawWindow,hWin,NULL,NULL,RDW_INVALIDATE
        return 0

   .elseif uMsg == WM_PAINT
        invoke BeginPaint,hWnd,ADDR Ps
            mov hDC,eax
          ;    MemDC   
            invoke BitBlt,hDC,0,0,cRect.right,cRect.bottom,hMemDC,0,0,SRCCOPY
        invoke EndPaint,hWnd,ADDR Ps
        return 0

   .elseif uMsg == WM_LBUTTONDOWN
      ;     
      ;       
      ;       ,
      ;        
      ;            
        mov ecx, 0h
        mov cx, WORD PTR [lParam]
        mov sPosX, ecx
        mov cPosX, ecx 
        mov cx, WORD PTR [lParam+2h]
        mov sPosY, ecx
        mov cPosY, ecx
      ;     (sFF)   
      ; (cFF)
        mov cl,cFF
        mov sFF,cl
      ;        
        .if (cFF == 1) || (cFF == 3) || (cFF == 5)
            invoke SelectObject,hMemDC,hLSPen
        .elseif (cFF == 2) || (cFF == 4)
            invoke SelectObject,hMemDC,hPen
            invoke SelectObject,hMemDC,hLBrush
        .endif
        return 0

   .elseif uMsg == WM_RBUTTONDOWN
        mov ecx, 0h
        mov cx, WORD PTR [lParam]
        mov sPosX, ecx
        mov cPosX, ecx
        mov cx, WORD PTR [lParam+2h]
        mov sPosY, ecx
        mov cPosY, ecx
        mov cl,cFF
        mov sFF,cl
        .if (cFF == 1) || (cFF == 3) || (cFF == 5)
            invoke SelectObject,hMemDC,hRSPen
	.elseif (cFF == 2) || (cFF == 4)
            invoke SelectObject,hMemDC,hPen
            invoke SelectObject,hMemDC,hRBrush
        .endif
        return 0

   .elseif uMsg == WM_LBUTTONUP
      ;    
        mov sFF,0
        invoke BitBlt,hMemBkDC,0,0,XM,YM,hMemDC,0,0,SRCCOPY
        return 0

   .elseif uMsg == WM_RBUTTONUP
        mov sFF,0
        invoke BitBlt,hMemBkDC,0,0,XM,YM,hMemDC,0,0,SRCCOPY
        return 0

    .elseif uMsg == WM_COMMAND
        cmp wParam,10101h     ;<<<<   "" -> ""
        jne @F
            invoke SendMessage,hWin,WM_SYSCOMMAND,SC_CLOSE,NULL
            return 0
        @@:

        cmp wParam,10201h     ;<<<<   "" -> ""
        jne @F
          ;       MemBkDC,    
          ;        
            invoke PatBlt,hMemBkDC,0,0,XM,YM,PATCOPY
            invoke BitBlt,hMemDC,0,0,XM,YM,hMemBkDC,0,0,SRCCOPY
            invoke RedrawWindow,hWin,NULL,NULL,RDW_INVALIDATE
            return 0
        @@:

      ;    ""
        cmp wParam,10301h
        jb @F
        cmp wParam,10305h
        ja @F
          ; ""    
            invoke CheckMenuItem,hMenu,Menu103,MF_UNCHECKED
            m2m Menu103,wParam

          ; ""    
            invoke CheckMenuItem,hMenu,wParam,MF_CHECKED

          ;     
          ;(  )
            mov cl,Byte Ptr [wParam]
          ;  
            mov cFF,cl
            return 0
        @@:

      ;    "" -> " "
        cmp wParam,10400h
        jb @F
        cmp wParam,10412h
        ja @F
            invoke CheckMenuItem,hMenu,Menu104,MF_UNCHECKED
            m2m Menu104,wParam

            invoke CheckMenuItem,hMenu,wParam,MF_CHECKED

          ;   "...",   ChooseColor .
          ;        LColor
            .if wParam == 10412h
                m2m cc.rgbResult,LColor
              	invoke ChooseColor,offset cc
              	m2m LColor,cc.rgbResult
            .else
                xor ecx,ecx
                mov cl, Byte Ptr [wParam]
                m2m LColor,DWord Ptr [Color+ecx*4]
            .endif

          ;     
            invoke DeleteObject,hLBrush
            invoke DeleteObject,hLSPen
            invoke CreateSolidBrush,LColor
            mov hLBrush,eax
            invoke CreatePen,PS_SOLID,sPen,LColor
            mov hLSPen,eax
            return 0
	@@:

      ;    "" -> " "
        cmp wParam,10500h
        jb @F
        cmp wParam,10512h
        ja @F
            invoke CheckMenuItem,hMenu,Menu105,MF_UNCHECKED
            m2m Menu105,wParam

            invoke CheckMenuItem,hMenu,wParam,MF_CHECKED

            .if wParam == 10512h
                m2m cc.rgbResult,RColor
              	invoke ChooseColor,offset cc
              	m2m RColor,cc.rgbResult
            .else
                xor ecx,ecx
                mov cl, Byte Ptr [wParam]
                m2m RColor,DWord Ptr [Color+ecx*4]
            .endif

            invoke DeleteObject,hRBrush
            invoke DeleteObject,hRSPen
            invoke CreateSolidBrush,RColor
            mov hRBrush,eax
            invoke CreatePen,PS_SOLID,sPen,RColor
            mov hRSPen,eax
            return 0
        @@:
 
     ;    "" -> " "
        cmp wParam,10601h
        jb @F
        cmp wParam,10605h
        ja @F
            invoke CheckMenuItem,hMenu,Menu106,MF_UNCHECKED
            m2m Menu106,wParam

            invoke CheckMenuItem,hMenu,wParam,MF_CHECKED

            xor ecx,ecx
            mov cl, Byte Ptr [wParam]
            mov sPen, ecx

          ;    
            invoke DeleteObject,hRSPen
            invoke DeleteObject,hLSPen
            invoke CreatePen,PS_SOLID,sPen,RColor
            mov hRSPen,eax
            invoke CreatePen,PS_SOLID,sPen,LColor
            mov hLSPen,eax
        @@:
        return 0

    .elseif uMsg == WM_SIZE
      ;       
        invoke GetClientRect,hWin,ADDR cRect
        return 0

    .elseif uMsg == WM_CREATE
      ;   .
        invoke GetDC,hWin
        mov hDC,eax
      ;     .
        invoke CreateCompatibleDC,eax
        mov hMemBkDC, eax
        invoke CreateCompatibleDC,hDC
        mov hMemDC, eax

      ;    ,   hDC.
        invoke CreateCompatibleBitmap,hDC,XM,YM
      ;     .
        invoke SelectObject,hMemBkDC,eax

        invoke CreateCompatibleBitmap,hDC,XM,YM
        invoke SelectObject,hMemDC,eax

      ;         
        invoke CreateSolidBrush,RGBW
        mov hLBrush,eax
        invoke SelectObject,hMemBkDC,eax
        invoke PatBlt,hMemBkDC,0,0,XM,YM,PATCOPY

        invoke SelectObject,hMemDC,hLBrush
	invoke PatBlt,hMemDC,0,0,XM,YM,PATCOPY
      ;    
        invoke ReleaseDC,hWin,hDC
        invoke DeleteObject,hLBrush

        invoke GetClientRect,hWin,ADDR cRect

      ;  ,  
      ; ""  ""
        invoke CreatePen,PS_NULL,1,0
        mov hPen,eax

      ;        
        invoke CreatePen,PS_SOLID,sPen,LColor
        mov hLSPen,eax
        invoke CreatePen,PS_SOLID,sPen,RColor
        mov hRSPen,eax
        invoke CreateSolidBrush,RColor
        mov hRBrush,eax
        invoke CreateSolidBrush,LColor
        mov hLBrush,eax
      ; CHOOSECOLOR ,   ChooseColor 
        mov cc.lStructSize,     sizeof CHOOSECOLOR
        m2m cc.hwndOwner,       hWin
        m2m cc.hInstance,       hInstance
        mov cc.lpCustColors,    offset CCCustColors
        mov cc.Flags,           CC_RGBINIT 
        return 0

   .elseif uMsg == WM_DESTROY
      ;  
        invoke DeleteObject,hRSPen
        invoke DeleteObject,hLSPen
        invoke DeleteObject,hPen
        invoke DeleteObject,hRBrush
        invoke DeleteObject,hLBrush
        invoke DeleteDC,hMemBkDC
        invoke DeleteDC,hMemDC
        invoke PostQuitMessage,NULL
        return 0
    .endif

    invoke DefWindowProc,hWin,uMsg,wParam,lParam
    ret
WndProc endp

;   
TopXY proc wDim:DWORD, sDim:DWORD
    shr sDim,1		;    2
    shr wDim,1		;    2
    mov eax,wDim	;    eax
    sub sDim,eax	;     
			; 
    return sDim
TopXY endp

end start